#include <bits/stdc++.h>

#define ll long long
#define ios ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);
#define mod 1000000009

using namespace std;

bool ch[2010][2010];
int ans[1000100],m[2010][2010];
int n,k;

int main(){
    ios;
    memset(m,0,sizeof(m));
    memset(ans,0,sizeof(ans));
    cin>>n>>k;
    for (int i=1;i<=n;i++){
        for (int j=1;j<=n;j++){
            cin>>m[i][j];
        }
    }
    for (int i=1;i<=n;i++){
        for (int j=1;j<=n;j++){
            int num=m[i][j];

            if (ch[i][j])continue;
            if (ans[num]!=0){
                ans[num]=-1;
                continue;
            }
            bool t=false;
            int cnt=1,ind=i;
            while(m[ind][j]==num){
                ch[ind][j]=true;
                ans[num]++;
                ind++;
            }
            for (int p=j+1;p<=n;p++){
                for (int q=i;q<ind;q++){
                    if (m[q][p]==num){
                        ans[num]++;
                        ch[q][p]=true;
                    }
                    else{
                        if (q!=i){
                            ans[num]=-1;
                        }
                        t=true;
                        break;
                    }
                }
                if (t)break;
            }
        }
    }
    int sum=0;
    for (int i=1;i<=k;i++){
        if (ans[i]>0)sum++;
    }
    cout<<sum;
    return 0;
}